/*
 * "Hello World" example.
 *
 * This example prints 'Hello from Nios II' to the STDOUT stream. It runs on
 * the Nios II 'standard', 'full_featured', 'fast', and 'low_cost' example
 * designs. It runs with or without the MicroC/OS-II RTOS and requires a STDOUT
 * device in your system's hardware.
 * The memory footprint of this hosted application is ~69 kbytes by default
 * using the standard reference design.
 *
 * For a reduced footprint version of this template, and an explanation of how
 * to reduce the memory footprint for a given application, see the
 * "small_hello_world" template.
 *
 */

#include <stdio.h>
#include "system.h"
#include "rsu5.h"
#include "altera_avalon_sysid_qsys_regs.h"
#include "altera_avalon_sysid_qsys.h"
#include "sys/alt_flash.h"

#define IMAGE1_ADDRESS 0x800000

int main()
{
	int input;
	alt_u32 condition_1,condition_2,boot_address_1,boot_address_2;
  alt_printf("Hello from Nios II! rev0.2\n");
  /* Read the hardware-tag, aka value0, from the hardware. */
  alt_printf("sysid = 0x%x\n",IORD_ALTERA_AVALON_SYSID_QSYS_ID(SYSID_QSYS_0_BASE));

  /* Read the time-of-generation, aka value1, from the hardware register. */
  alt_printf("timestamp = 0x%x\n",IORD_ALTERA_AVALON_SYSID_QSYS_TIMESTAMP(SYSID_QSYS_0_BASE));

  alt_printf("RCU current state = 0x%x\n",rsu_get_current_state_mode(RSU_CYCLONE5_0_BASE));
 /* rsu_factory_get_previous_reconfig_status(
		  RSU_CYCLONE5_0_BASE,
  			&condition_1,
  			&condition_2,
  			&boot_address_1,
  			&boot_address_2);
  alt_printf("previous_reconfig_status\n");
  alt_printf("  condition1 = 0x%x\n",condition_1);
  alt_printf("  condition2 = 0x%x\n",condition_2);
  alt_printf("  boot_address_1 = 0x%x \n",boot_address_1);
  alt_printf("  boot_address_2 = 0x%x \n",boot_address_2);*/
  while(1){
	  alt_printf("Enter ");
	  alt_printf("0 to go to the factory image\n ");
//	  alt_printf("1 to go to the 1st users image 0x800000\n");
//	  alt_printf("2 to go to the 1st users image 0x800000>>1\n");
	  alt_printf("3 to go to the 1st users image 0x800000>>2\n");
	  alt_printf("4 to jump to a bad address\n\n");
	  input = alt_getchar();
	  alt_putchar(input);
	  	  if(input =='0')
	  	  {
	  		alt_printf("configuration #0\n");
	  		alt_printf("reconfiguring \n ********* restart the nios2-terminal **********\n");
	  		alt_putchar(0x04);
	  		rsu_factory_trigger_reconfig(RSU_CYCLONE5_0_BASE,0,0);

	  	  }else if(input=='1'){
	  		  alt_printf("configuration #1\n");
	  		alt_printf("reconfiguring \n ********* restart the nios2-terminal **********\n");
	  			  		alt_putchar(0x04);
	  		rsu_factory_trigger_reconfig(RSU_CYCLONE5_0_BASE,IMAGE1_ADDRESS,0);
	  	  }else if(input=='2'){
	  		  alt_printf("configuration #2\n");
	  		alt_printf("reconfiguring \n ********* restart the nios2-terminal **********\n");
	  			  		alt_putchar(0x04);
	  		rsu_factory_trigger_reconfig(RSU_CYCLONE5_0_BASE,IMAGE1_ADDRESS>>1,0);
	  	  }else if(input=='3'){
	  		  alt_printf("configuration #3\n");
	  		alt_printf("reconfiguring \n ********* restart the nios2-terminal **********\n");
	  			  		alt_putchar(0x04);
	  		rsu_factory_trigger_reconfig(RSU_CYCLONE5_0_BASE,IMAGE1_ADDRESS>>2,0);

	  	  }else if(input=='4'){
	  		  alt_printf("configuration #4\n");
	  		alt_printf("reconfiguring \n ********* restart the nios2-terminal **********\n");
	  	    alt_putchar(0x04);
	  		rsu_factory_trigger_reconfig(RSU_CYCLONE5_0_BASE,0x12345,0);
          }/*else if(input=='a'){
        	  int i,j;
        	  alt_flash_fd* fd;
        	  fd = alt_flash_open_dev(EPCS_FLASH_CONTROLLER_0_NAME);
        	  unsigned long buff[32];
        	  for(i=0;i<0x200000;i+=0x10000)
        	  {
        	     alt_printf("\n\nreading flash 0x%x\n",i);
        	     if (fd!=NULL)
        	     {
        	       alt_read_flash(fd, i, (char *)buff, 32*4);
        	       for( j=0;j<32;j++)
        	       {
        	    	   printf("%x ",buff[j]);
        	       }
        	     }
        	  }
          }*/else {
        	  alt_putchar("\n");
          }
  }
  return 0;
}
